diff --git a/runtest/ltp-aio-stress b/runtest/ltp-aio-stress
index 4b0b81ce2..1de49b406 100644
--- a/runtest/ltp-aio-stress
+++ b/runtest/ltp-aio-stress
@@ -1,55 +1,55 @@
 # ltp A-sync IO Stress IO tests
-ADS1000 aio-stress -o2 -r4 -f1
-ADS1001 aio-stress -o2 -r8 -f1
-ADS1002 aio-stress -o2 -r16 -f1
-ADS1003 aio-stress -o2 -r32 -t2 -f2
-ADS1004 aio-stress -o2 -r64 -f2
-ADS1005 aio-stress -o3 -r4 -f2
-ADS1006 aio-stress -o3 -r8 -f2
-ADS1007 aio-stress -o3 -r16 -f2
-ADS1008 aio-stress -o3 -r32 -f4
-ADS1009 aio-stress -o3 -r64 -t4 -f4
-ADS1010 aio-stress -o3 -r128 -t4 -f4
-ADS1011 aio-stress -o3 -r256 -t8 -f8
-ADS1012 aio-stress -o3 -r512 -t8 -f8
-ADS1013 aio-stress -o2 -O -r4 -t8 -f8
-ADS1014 aio-stress -o2 -O -r8 -f2
-ADS1015 aio-stress -o2 -O -r16 -f2
-ADS1016 aio-stress -o2 -O -r32 -t2 -f2
-ADS1017 aio-stress -o2 -O -r64 -t2 -f2
-ADS1018 aio-stress -o3 -O -r4 -t2 -f2
-ADS1019 aio-stress -o3 -O -r8 -t2 -f2
-ADS1020 aio-stress -o3 -O -r16 -t2 -f2
-ADS1021 aio-stress -o3 -O -r32 -t4 -f4
-ADS1022 aio-stress -o3 -O -r64 -t4 -f4
-ADS1023 aio-stress -o3 -O -r128 -t4 -f4
-ADS1024 aio-stress -o3 -O -r256 -t8 -f8
-ADS1025 aio-stress -o3 -O -r512 -t8 -f8
-ADS1026 aio-stress -o0 -r4 -t8 -f8
-ADS1027 aio-stress -o0 -r8 -f1
-ADS1028 aio-stress -o0 -r16 -f1
-ADS1029 aio-stress -o0 -r32 -t2 -f2
-ADS1030 aio-stress -o0 -r64 -t2 -f2
-ADS1031 aio-stress -o1 -r4 -t2 -f1
-ADS1032 aio-stress -o1 -r8 -t2 -f1
-ADS1033 aio-stress -o1 -r16 -t2 -f2
-ADS1034 aio-stress -o1 -r32 -t4 -f4
-ADS1035 aio-stress -o1 -r64 -t4 -f4
-ADS1036 aio-stress -o1 -r128 -t4 -f4
-ADS1037 aio-stress -o1 -r256 -t8 -f8
-ADS1038 aio-stress -o1 -r512 -t8 -f8
-ADS1039 aio-stress -o1 -O -r4 -t8 -f8
-ADS1040 aio-stress -o1 -O -r8 -t2 -f2
-ADS1041 aio-stress -o1 -O -r16 -t2 -f2
-ADS1042 aio-stress -o1 -O -r32 -t2 -f2
-ADS1043 aio-stress -o1 -O -r64 -t2 -f2
-ADS1044 aio-stress -o1 -O -r4 -t4 -f4
-ADS1045 aio-stress -o1 -O -r8 -t4 -f4
-ADS1046 aio-stress -o1 -O -r16 -t4 -f4
-ADS1047 aio-stress -o1 -O -r32 -t8 -f8
-ADS1048 aio-stress -o1 -O -r64 -t8 -f8
-ADS1049 aio-stress -o1 -O -r128 -t8 -f8
-ADS1050 aio-stress -o1 -O -r256 -t2 -f2
-ADS1051 aio-stress -o3 -r8 -t2 -f2
-ADS1052 aio-stress -o3 -r16 -t2 -f2
-ADS1053 aio-stress -o3 -r32 -t4 -f4
+ADS1000 aio-stress -o2 -r4k -f1
+ADS1001 aio-stress -o2 -r8k -f1
+ADS1002 aio-stress -o2 -r16k -f1
+ADS1003 aio-stress -o2 -r32k -t2 -f2
+ADS1004 aio-stress -o2 -r64k -f2
+ADS1005 aio-stress -o3 -r4k -f2
+ADS1006 aio-stress -o3 -r8k -f2
+ADS1007 aio-stress -o3 -r16k -f2
+ADS1008 aio-stress -o3 -r32k -f4
+ADS1009 aio-stress -o3 -r64k -t4 -f4
+ADS1010 aio-stress -o3 -r128k -t4 -f4
+ADS1011 aio-stress -o3 -r256k -t8 -f8
+ADS1012 aio-stress -o3 -r512k -t8 -f8
+ADS1013 aio-stress -o2 -O -r4k -t8 -f8
+ADS1014 aio-stress -o2 -O -r8k -f2
+ADS1015 aio-stress -o2 -O -r16k -f2
+ADS1016 aio-stress -o2 -O -r32k -t2 -f2
+ADS1017 aio-stress -o2 -O -r64k -t2 -f2
+ADS1018 aio-stress -o3 -O -r4k -t2 -f2
+ADS1019 aio-stress -o3 -O -r8k -t2 -f2
+ADS1020 aio-stress -o3 -O -r16k -t2 -f2
+ADS1021 aio-stress -o3 -O -r32k -t4 -f4
+ADS1022 aio-stress -o3 -O -r64k -t4 -f4
+ADS1023 aio-stress -o3 -O -r128k -t4 -f4
+ADS1024 aio-stress -o3 -O -r256k -t8 -f8
+ADS1025 aio-stress -o3 -O -r512k -t8 -f8
+ADS1026 aio-stress -o0 -r4k -t8 -f8
+ADS1027 aio-stress -o0 -r8k -f1
+ADS1028 aio-stress -o0 -r16k -f1
+ADS1029 aio-stress -o0 -r32k -t2 -f2
+ADS1030 aio-stress -o0 -r64k -t2 -f2
+ADS1031 aio-stress -o1 -r4k -t2 -f1
+ADS1032 aio-stress -o1 -r8k -t2 -f1
+ADS1033 aio-stress -o1 -r16k -t2 -f2
+ADS1034 aio-stress -o1 -r32k -t4 -f4
+ADS1035 aio-stress -o1 -r64k -t4 -f4
+ADS1036 aio-stress -o1 -r128k -t4 -f4
+ADS1037 aio-stress -o1 -r256k -t8 -f8
+ADS1038 aio-stress -o1 -r512k -t8 -f8
+ADS1039 aio-stress -o1 -O -r4k -t8 -f8
+ADS1040 aio-stress -o1 -O -r8k -t2 -f2
+ADS1041 aio-stress -o1 -O -r16k -t2 -f2
+ADS1042 aio-stress -o1 -O -r32k -t2 -f2
+ADS1043 aio-stress -o1 -O -r64k -t2 -f2
+ADS1044 aio-stress -o1 -O -r4k -t4 -f4
+ADS1045 aio-stress -o1 -O -r8k -t4 -f4
+ADS1046 aio-stress -o1 -O -r16k -t4 -f4
+ADS1047 aio-stress -o1 -O -r32k -t8 -f8
+ADS1048 aio-stress -o1 -O -r64k -t8 -f8
+ADS1049 aio-stress -o1 -O -r128k -t8 -f8
+ADS1050 aio-stress -o1 -O -r256k -t2 -f2
+ADS1051 aio-stress -o3 -r8k -t2 -f2
+ADS1052 aio-stress -o3 -r16k -t2 -f2
+ADS1053 aio-stress -o3 -r32k -t4 -f4