diff --git a/runtest/net.nfs b/runtest/net.nfs
index 15a960017..7556ed4fc 100644
--- a/runtest/net.nfs
+++ b/runtest/net.nfs
@@ -2,107 +2,107 @@
 #
 # PLEASE READ THE README FILE network/README.md BEFORE RUNNING THESE.
 #
-nfs3_01 nfs01.sh -v 3 -t udp
-nfs3t_01 nfs01.sh -v 3 -t tcp
-nfs4_01 nfs01.sh -v 4 -t tcp
-nfs41_01 nfs01.sh -v 4.1 -t tcp
-nfs42_01 nfs01.sh -v 4.2 -t tcp
-nfs3_ipv6_01 nfs01.sh -6 -v 3 -t udp
-nfs3t_ipv6_01 nfs01.sh -6 -v 3 -t tcp
-nfs4_ipv6_01 nfs01.sh -6 -v 4 -t tcp
-nfs41_ipv6_01 nfs01.sh -6 -v 4.1 -t tcp
-nfs42_ipv6_01 nfs01.sh -6 -v 4.2 -t tcp
+nfs01.sh_v3_ipv4_udp nfs01.sh -v 3 -t udp
+nfs01.sh_v3_ipv4_tcp nfs01.sh -v 3 -t tcp
+nfs01.sh_v4_ipv4_tcp nfs01.sh -v 4 -t tcp
+nfs01.sh_v4.1_ipv4_tcp nfs01.sh -v 4.1 -t tcp
+nfs01.sh_v4.2_ipv4_tcp nfs01.sh -v 4.2 -t tcp
+nfs01.sh_v3_ipv6_udp nfs01.sh -6 -v 3 -t udp
+nfs01.sh_v3_ipv6_tcp nfs01.sh -6 -v 3 -t tcp
+nfs01.sh_v4_ipv6_tcp nfs01.sh -6 -v 4 -t tcp
+nfs01.sh_v4.1_ipv6_tcp nfs01.sh -6 -v 4.1 -t tcp
+nfs01.sh_v4.2_ipv6_tcp nfs01.sh -6 -v 4.2 -t tcp
 
-nfs3_02 nfs02.sh -v 3 -t udp
-nfs3t_02 nfs02.sh -v 3 -t tcp
-nfs4_02 nfs02.sh -v 4 -t tcp
-nfs41_02 nfs02.sh -v 4.1 -t tcp
-nfs42_02 nfs02.sh -v 4.2 -t tcp
-nfs3_ipv6_02 nfs02.sh -6 -v 3 -t udp
-nfs3t_ipv6_02 nfs02.sh -6 -v 3 -t tcp
-nfs4_ipv6_02 nfs02.sh -6 -v 4 -t tcp
-nfs41_ipv6_02 nfs02.sh -6 -v 4.1 -t tcp
-nfs42_ipv6_02 nfs02.sh -6 -v 4.2 -t tcp
+nfs02.sh_v3_ipv4_udp nfs02.sh -v 3 -t udp
+nfs02.sh_v3_ipv4_tcp nfs02.sh -v 3 -t tcp
+nfs02.sh_v4_ipv4_tcp nfs02.sh -v 4 -t tcp
+nfs02.sh_v4.1_ipv4_tcp nfs02.sh -v 4.1 -t tcp
+nfs02.sh_v4.2_ipv4_tcp nfs02.sh -v 4.2 -t tcp
+nfs02.sh_v3_ipv6_udp nfs02.sh -6 -v 3 -t udp
+nfs02.sh_v3_ipv6_tcp nfs02.sh -6 -v 3 -t tcp
+nfs02.sh_v4_ipv6_tcp nfs02.sh -6 -v 4 -t tcp
+nfs02.sh_v4.1_ipv6_tcp nfs02.sh -6 -v 4.1 -t tcp
+nfs02.sh_v4.2_ipv6_tcp nfs02.sh -6 -v 4.2 -t tcp
 
-nfs3_03 nfs03.sh -v 3 -t udp
-nfs3t_03 nfs03.sh -v 3 -t tcp
-nfs4_03 nfs03.sh -v 4 -t tcp
-nfs41_03 nfs03.sh -v 4.1 -t tcp
-nfs42_03 nfs03.sh -v 4.2 -t tcp
-nfs3_ipv6_03 nfs03.sh -6 -v 3 -t udp
-nfs3t_ipv6_03 nfs03.sh -6 -v 3 -t tcp
-nfs4_ipv6_03 nfs03.sh -6 -v 4 -t tcp
-nfs41_ipv6_03 nfs03.sh -6 -v 4.1 -t tcp
-nfs42_ipv6_03 nfs03.sh -6 -v 4.2 -t tcp
+nfs03.sh_v3_ipv4_udp nfs03.sh -v 3 -t udp
+nfs03.sh_v3_ipv4_tcp nfs03.sh -v 3 -t tcp
+nfs03.sh_v4_ipv4_tcp nfs03.sh -v 4 -t tcp
+nfs03.sh_v4.1_ipv4_tcp nfs03.sh -v 4.1 -t tcp
+nfs03.sh_v4.2_ipv4_tcp nfs03.sh -v 4.2 -t tcp
+nfs03.sh_v3_ipv6_udp nfs03.sh -6 -v 3 -t udp
+nfs03.sh_v3_ipv6_tcp nfs03.sh -6 -v 3 -t tcp
+nfs03.sh_v4_ipv6_tcp nfs03.sh -6 -v 4 -t tcp
+nfs03.sh_v4.1_ipv6_tcp nfs03.sh -6 -v 4.1 -t tcp
+nfs03.sh_v4.2_ipv6_tcp nfs03.sh -6 -v 4.2 -t tcp
 
-nfs3_04 nfs04.sh -v 3 -t udp
-nfs3t_04 nfs04.sh -v 3 -t tcp
-nfs4_04 nfs04.sh -v 4 -t tcp
-nfs41_04 nfs04.sh -v 4.1 -t tcp
-nfs42_04 nfs04.sh -v 4.2 -t tcp
-nfs3_ipv6_04 nfs04.sh -6 -v 3 -t udp
-nfs3t_ipv6_04 nfs04.sh -6 -v 3 -t tcp
-nfs4_ipv6_04 nfs04.sh -6 -v 4 -t tcp
-nfs41_ipv6_04 nfs04.sh -6 -v 4.1 -t tcp
-nfs42_ipv6_04 nfs04.sh -6 -v 4.2 -t tcp
+nfs04.sh_v3_ipv4_udp nfs04.sh -v 3 -t udp
+nfs04.sh_v3_ipv4_tcp nfs04.sh -v 3 -t tcp
+nfs04.sh_v4_ipv4_tcp nfs04.sh -v 4 -t tcp
+nfs04.sh_v4.1_ipv4_tcp nfs04.sh -v 4.1 -t tcp
+nfs04.sh_v4.2_ipv4_tcp nfs04.sh -v 4.2 -t tcp
+nfs04.sh_v3_ipv6_udp nfs04.sh -6 -v 3 -t udp
+nfs04.sh_v3_ipv6_tcp nfs04.sh -6 -v 3 -t tcp
+nfs04.sh_v4_ipv6_tcp nfs04.sh -6 -v 4 -t tcp
+nfs04.sh_v4.1_ipv6_tcp nfs04.sh -6 -v 4.1 -t tcp
+nfs04.sh_v4.2_ipv6_tcp nfs04.sh -6 -v 4.2 -t tcp
 
-nfs3_05 nfs05.sh -v 3 -t udp
-nfs3t_05 nfs05.sh -v 3 -t tcp
-nfs4_05 nfs05.sh -v 4 -t tcp
-nfs41_05 nfs05.sh -v 4.1 -t tcp
-nfs42_05 nfs05.sh -v 4.2 -t tcp
-nfs3_ipv6_05 nfs05.sh -6 -v 3 -t udp
-nfs3t_ipv6_05 nfs05.sh -6 -v 3 -t tcp
-nfs4_ipv6_05 nfs05.sh -6 -v 4 -t tcp
-nfs41_ipv6_05 nfs05.sh -6 -v 4.1 -t tcp
-nfs42_ipv6_05 nfs05.sh -6 -v 4.2 -t tcp
+nfs05.sh_v3_ipv4_udp nfs05.sh -v 3 -t udp
+nfs05.sh_v3_ipv4_tcp nfs05.sh -v 3 -t tcp
+nfs05.sh_v4_ipv4_tcp nfs05.sh -v 4 -t tcp
+nfs05.sh_v4.1_ipv4_tcp nfs05.sh -v 4.1 -t tcp
+nfs05.sh_v4.2_ipv4_tcp nfs05.sh -v 4.2 -t tcp
+nfs05.sh_v3_ipv6_udp nfs05.sh -6 -v 3 -t udp
+nfs05.sh_v3_ipv6_tcp nfs05.sh -6 -v 3 -t tcp
+nfs05.sh_v4_ipv6_tcp nfs05.sh -6 -v 4 -t tcp
+nfs05.sh_v4.1_ipv6_tcp nfs05.sh -6 -v 4.1 -t tcp
+nfs05.sh_v4.2_ipv6_tcp nfs05.sh -6 -v 4.2 -t tcp
 
-nfs01_06  nfs06.sh -v "3,3,3,4,4,4" -t "udp,udp,tcp,tcp,tcp,tcp"
-nfs02_06 nfs06.sh -v "3,4,4.1,4.2,4.2,4.2" -t "tcp,tcp,tcp,tcp,tcp,tcp"
-nfs03_ipv6_06 nfs06.sh -6 -v "4,4.1,4.1,4.2,4.2,4.2" -t "tcp,tcp,tcp,tcp,tcp,tcp"
+nfs06.sh_v3_v4_ipv4_tcp_udp  nfs06.sh -v "3,3,3,4,4,4" -t "udp,udp,tcp,tcp,tcp,tcp"
+nfs06.sh_vall_ipv4tcp nfs02_06 nfs06.sh -v "3,4,4.1,4.2,4.2,4.2" -t "tcp,tcp,tcp,tcp,tcp,tcp"
+nfs06.sh_v4*_ipv6_tcp nfs03_ipv6_06 nfs06.sh -6 -v "4,4.1,4.1,4.2,4.2,4.2" -t "tcp,tcp,tcp,tcp,tcp,tcp"
 
-nfs3_07 nfs07.sh -v 3 -t udp
-nfs3t_07 nfs07.sh -v 3 -t tcp
-nfs4_07 nfs07.sh -v 4 -t tcp
-nfs41_07 nfs07.sh -v 4.1 -t tcp
-nfs42_07 nfs07.sh -v 4.2 -t tcp
-nfs3_ipv6_07 nfs07.sh -6 -v 3 -t udp
-nfs3t_ipv6_07 nfs07.sh -6 -v 3 -t tcp
-nfs4_ipv6_07 nfs07.sh -6 -v 4 -t tcp
-nfs41_ipv6_07 nfs07.sh -6 -v 4.1 -t tcp
-nfs42_ipv6_07 nfs07.sh -6 -v 4.2 -t tcp
+nfs07.sh_v3_ipv4_udp nfs07.sh -v 3 -t udp
+nfs07.sh_v3_ipv4_tcp nfs07.sh -v 3 -t tcp
+nfs07.sh_v4_ipv4_tcp nfs07.sh -v 4 -t tcp
+nfs07.sh_v4.1_ipv4_tcp nfs07.sh -v 4.1 -t tcp
+nfs07.sh_v4.2_ipv4_tcp nfs07.sh -v 4.2 -t tcp
+nfs07.sh_v3_ipv6_udp nfs07.sh -6 -v 3 -t udp
+nfs07.sh_v3_ipv6_tcp nfs07.sh -6 -v 3 -t tcp
+nfs07.sh_v4_ipv6_tcp nfs07.sh -6 -v 4 -t tcp
+nfs07.sh_v4.1_ipv6_tcp nfs07.sh -6 -v 4.1 -t tcp
+nfs07.sh_v4.2_ipv6_tcp nfs07.sh -6 -v 4.2 -t tcp
 
-nfs3_08 nfs08.sh -v 3 -t udp
-nfs3t_08 nfs08.sh -v 3 -t tcp
-nfs4_08 nfs08.sh -v 4 -t tcp
-nfs41_08 nfs08.sh -v 4.1 -t tcp
-nfs42_08 nfs08.sh -v 4.2 -t tcp
-nfs3_ipv6_08 nfs08.sh -6 -v 3 -t udp
-nfs3t_ipv6_08 nfs08.sh -6 -v 3 -t tcp
-nfs4_ipv6_08 nfs08.sh -6 -v 4 -t tcp
-nfs41_ipv6_08 nfs08.sh -6 -v 4.1 -t tcp
-nfs42_ipv6_08 nfs08.sh -6 -v 4.2 -t tcp
+nfs08.sh_v3_ipv4_udp nfs08.sh -v 3 -t udp
+nfs08.sh_v3_ipv4_tcp nfs08.sh -v 3 -t tcp
+nfs08.sh_v4_ipv4_tcp nfs08.sh -v 4 -t tcp
+nfs08.sh_v4.1_ipv4_tcp nfs08.sh -v 4.1 -t tcp
+nfs08.sh_v4.2_ipv4_tcp nfs08.sh -v 4.2 -t tcp
+nfs08.sh_v3_ipv6_udp nfs08.sh -6 -v 3 -t udp
+nfs08.sh_v3_ipv6_tcp nfs08.sh -6 -v 3 -t tcp
+nfs08.sh_v4_ipv6_tcp nfs08.sh -6 -v 4 -t tcp
+nfs08.sh_v4.1_ipv6_tcp nfs08.sh -6 -v 4.1 -t tcp
+nfs08.sh_v4.2_ipv6_tcp nfs08.sh -6 -v 4.2 -t tcp
 
-nfslock3_01 nfslock01.sh -v 3 -t udp
-nfslock3t_01 nfslock01.sh -v 3 -t tcp
-nfslock4_01 nfslock01.sh -v 4 -t tcp
-nfslock41_01 nfslock01.sh -v 4.1 -t tcp
-nfslock42_01 nfslock01.sh -v 4.2 -t tcp
-nfslock3_ipv6_01 nfslock01.sh -6 -v 3 -t udp
-nfslock3t_ipv6_01 nfslock01.sh -6 -v 3 -t tcp
-nfslock4_ipv6_01 nfslock01.sh -6 -v 4 -t tcp
-nfslock41_ipv6_01 nfslock01.sh -6 -v 4.1 -t tcp
-nfslock42_ipv6_01 nfslock01.sh -6 -v 4.2 -t tcp
+nfslock01.sh_v3_ipv4_udp nfslock01.sh -v 3 -t udp
+nfslock01.sh_v3_ipv4_tcp nfslock01.sh -v 3 -t tcp
+nfslock01.sh_v4_ipv4_tcp nfslock01.sh -v 4 -t tcp
+nfslock01.sh_v4.1_ipv4_tcp nfslock01.sh -v 4.1 -t tcp
+nfslock01.sh_v4.2_ipv4_tcp nfslock01.sh -v 4.2 -t tcp
+nfslock01.sh_v3_ipv6_udp nfslock01.sh -6 -v 3 -t udp
+nfslock01.sh_v3_ipv6_tcp nfslock01.sh -6 -v 3 -t tcp
+nfslock01.sh_v4_ipv6_tcp nfslock01.sh -6 -v 4 -t tcp
+nfslock01.sh_v4.1_ipv6_tcp nfslock01.sh -6 -v 4.1 -t tcp
+nfslock01.sh_v4.2_ipv6_tcp nfslock01.sh -6 -v 4.2 -t tcp
 
-nfsstat3_01 nfsstat01.sh
+nfsstat3.sh nfsstat01.sh
 
-nfsx3 fsx.sh -v 3 -t udp
-nfsx3t fsx.sh -v 3 -t tcp
-nfsx4 fsx.sh -v 4 -t tcp
-nfsx41 fsx.sh -v 4.1 -t tcp
-nfsx42 fsx.sh -v 4.2 -t tcp
-nfsx3_ipv6 fsx.sh -6 -v 3 -t udp
-nfsx3t_ipv6 fsx.sh -6 -v 3 -t tcp
-nfsx4_ipv6 fsx.sh -6 -v 4 -t tcp
-nfsx41_ipv6 fsx.sh -6 -v 4.1 -t tcp
-nfsx42_ipv6 fsx.sh -6 -v 4.2 -t tcp
+fsx.sh_v3_ipv4_udp fsx.sh -v 3 -t udp
+fsx.sh_v3_ipv4_tcp fsx.sh -v 3 -t tcp
+fsx.sh_v4_ipv4_tcp fsx.sh -v 4 -t tcp
+fsx.sh_v4.1_ipv4_tcp fsx.sh -v 4.1 -t tcp
+fsx.sh_v4.2_ipv4_tcp fsx.sh -v 4.2 -t tcp
+fsx.sh_v3_ipv6_udp fsx.sh -6 -v 3 -t udp
+fsx.sh_v3_ipv6_tcp fsx.sh -6 -v 3 -t tcp
+fsx.sh_v4_ipv6_tcp fsx.sh -6 -v 4 -t tcp
+fsx.sh_v4.1_ipv6_tcp fsx.sh -6 -v 4.1 -t tcp
+fsx.sh_v4.2_ipv6_tcp fsx.sh -6 -v 4.2 -t tcp